HPHP48-W,*
	    TITLE Multi-Row Chr Browser, Ver 1.2a
** begin ez ***************************************************
*****************************************************************
**
** NAME: EZCHAR
**
** CATEGORY: Utils
**
** ABSTRACT: Character browser!
**
** AUTHOR:   Daniel Lidstrom danli97@ite.mh.se www.ite.mh.se/~danli97
**
** CREDITS TO: Mika Heiskanen&Rick Grevelle for some display routines
**
** MODULE HISTORY:      980327 Written
**		ver 1.1 - 980331 Formatted source, fixed a bug
**		ver 1.2 - 980403 Enlarged big char
**				 Added About
**				 Added ASCII display
**		ver 1.2a - fixed a bug when exiting
*****************************************************************
*****************************************************************

xROMID  640
xTITLE  EZCHAR v1.2a -Daniel Lidstr\F6m '98
xCONFIG CFG

LABEL CFG
:: 640 TOSRRP ;

NIBB 1 8
xNAME EZCHAR
::
 CK0
 EditLExists?
 EDITLINE$
 PTR 13EF1
 INSERT?
 PrgmEntry?
 AlgEntry?
 PTR 53992
 SEVEN
 '
 NULLLAM
 CACHE
 InitEd&Modes
 EZMAIN
 ::
    NOTcase
    NULL$
 ;
 8GETLAM
 IT
 ::
  7GETLAM
  EditString
  6GETLAM
  #1+
  PTR 43309
 ;
 5GETLAM
 ?SKIP
 REPLACE_MODE
 4GETLAM
 IT
 SetPrgmEntry
 3GETLAM
 IT
 SetAlgEntry
 2GETLAM
 IT
 PTR 539A0
 ABND
 DUPNULL$?
 caseDROP
 Echo$NoChr00
;

NIBB 1 8
xNAME EZINST
::
  ' :: TakeOver xEZCHAR ;
  % 22.3 xASN
;


	    STITLE Multi-Row Chr Browser Main, Ver 1.0
*****************************************************************
*****************************************************************
**
** NAME: EZMAIN
**
** ENTRY:
**
** EXIT: 
**		    
** CALLS: SAVPTR, CINRTN, AllowIntr, GETPTRLOOP.
**
** ABSTRACT: Character browser main object
**
** MODULE HISTORY: Written 980327 Daniel Lidstrom
**
**
*****************************************************************
*****************************************************************
NIBB 1 8
NULLNAME EZMAIN

INCLUDE SYMBOLS.S
DEFINE	FNT2		ROMPTR 101 4

ASSEMBLE
ezCURSOR	EQU	3
ezASCII	EQU	4
ezALPHA	EQU	5
ezPRESS	EQU	6
ezSOUND	EQU	8
ezPUSHED	EQU	9
onerow	EQU	34	number of nibbles per row
dblp	EQU	6	6 passes with BITMAP stable
=allkeys	EQU	#1FF
RPL

::
 RECLAIMDISP
 TURNMENUOFF
 NULL$			  ( Data string 5 nibs for D0, 5 for address )
 15 EXPAND
 FNT2			  ( UFL medium font set )
 INCLUDE CHRDAT.S
  56 TestSysFlag		( Sound flag )
* Register allocation:
*	[A]		[A1]		[A2]		[S]
* R0    scratch for CMPT
* R1	->string
* R2	->cursor
* R3	->display
* R4	->font
* D0	->memory

CODE

	GOSUBL  EZINIT


** Start main loop
	A=R2
	D0=A	    *       D0 = ->memory start address
** Main memory scanner loop.
scan    INTOFF	  disables interupts
	ST=0	15
	CD0EX		   \ 
	RSTK=C		  save memory start
	D0=C		    /
	GOSUB		   dispdmp update the display
	C=RSTK
	D0=C		    D0->:memory starts
	GOSUB	WaitScanKey	B[B] = key
	GOC	ExScan
	GOSUB	DoTabKey
	GOTO	scan

ExScan	GOSUB	NODOWN?
	GOSUB	busyon
	?ST=0   ezPUSHED	Character to push?
	GOYES   +	       If not, skip
	GOSBVL	=D1=DSKTOP
	C=DAT1	A
	D1=C
	D1=D1+	15
	A=DAT1	A
	GOSBVL	=GETPTR
	DAT1=A	A
	GOVLNG	=PushTLoop
+	GOVLNG	=GPOverWrFLp

**********************************************************************
* Name:		WaitScanKey
**********************************************************************
WaitScanKey

** Setup key repeat speed / delay
	D1=(5)	=TIMERCTRL.1	[SRQ WKE INT XTRA]
	LC(1)	4	[ 0   1   0   0  ]
	DAT1=C	1
	D1=(2)	=TIMER1
	LC(1)   2       3/16 second delay
	?ST=0	ezPRESS
	GOYES	settim1
	LC(1)   0	       Minimum delay for repeat speed
*	C=DAT1	B		Advance based on last timer value
*	C=C+1	P
*	GOC	settim1
*	LC(1)	#F
settim1	DAT1=C	1
	LC(3)	=allkeys
	OUT=C	loads	all keyboard
**	******
	SHUTDN	WAIT	FOR INTERUPTS
**	******
	D1=(2)	=TIMERCTRL.1
** Trap illegitimate wakeups.
enough?	GOSBVL	=BITMAP
	RTNC		    Carry if ON key down
	?A=0    W	       catch no keys down
	GOYES	eztimeout
	C=DAT1	B
	?CBIT=0 3	       legitimate wakeup?
	GOYES   enough?	 NO, keep checking!
	B=A	W
	ST=1    ezPRESS	 Flag repeat is ok
	GOTO	count00

** Set 10 minute timeout
eztimeout
	D1=(5)	=ANNCTRL
	C=DAT1  B	       C[B]:[AON XTRA io busy alarm alpha -> <-]
	CBIT=0  4	       C[B]:[ *    *  *   0     *     *   *  * ]
	DAT1=C  B	       turn off busy annunciator
	CD0EX
	RSTK=C		  RSTK=->memory
	GOSBVL	=GetTimChk
	A=0	W
	LA(6)	10*60*8192	10 minute timeout
*	LA(6)	10*8192		10 second timeout
	A=A+C	W
	GOSBVL	=WrtTIMEOUTA
	C=ST	X
	RSTK=C		  RSTK=->st->memory
	CLRST		   Clear sCLKON
	GOSBVL  =CMPT	   Setup timeout/alarm wakeup
	C=RSTK
	ST=C	X
	C=RSTK
	D0=C		    D0=->memory

** Set 4/8 second cursor blink

blink	D1=(5)	=TIMERCTRL.1	[SRQ WKE INT XTRA]
	LC(1)   4	       [ 0   1   0   0  ]
	DAT1=C	1
	D1=(2)	=TIMER1
	LC(1)   7	       4/8 seconds
	DAT1=C	1
	LC(3)	=allkeys
	OUT=C		   loads all keyboard
**	******
	SHUTDN
**	******
	D1=(2)	=TIMERCTRL.1
	C=DAT1	B
	?CBIT=1 7	       wtimeout/alarm?
	RTNYES		  Carry if timeout
	?CBIT=0 3	       blink?
	GOYES	blink01
	GOSUBL  CURSOR+	 Yes
blink01	GOSBVL	=BITMAP
	RTNC		    carry if [ON] down
	?A=0    W	       catch no keys down
	GOYES   blink	   fall asleep again
	ST=0    ezPRESS	 Flag key just down

** Key debounce loop.
dbnce00	B=A	W
	D1=(5)	(=TIMER2)+1
dbnce01	C=DAT1	S	<--- ( hang until match ) <---------
	P=      14					  |
	LC(1)   (dblp)-1				    |
dbnce02	A=DAT1	S	<<-- ( hang until stable ) <<---    |
	?A=C    S	   |			   |   |
	GOYES	dbnce02	---	wait for TIMER2[1] tick	|   |
	C=A     S       save the TIMER2[1] tick	 |   |
	GOSBVL  =BITMAP A[12-0]:kbd bitmap	      |   |
	RTNC    carry   if [ON] down		    |   |
	?A=0    W       catch no keys down	      |   |
	GOYES   blink				   |   |
	ABEX    W       A[12-0]:old B[12-0]:new	 |   |
	?A#B    W       match?			  |   |
	GOYES	dbnce01	--> ( no ) ------------------------
	P=      14				      |
	C=C-1   P       stable long enough?	     |
	GONC	dbnce02	--> ( no ) --------------------
	P=	0

** Insure only 1 key is being held down.
** Here A[12-0]=B[12-0]:stable kbd bitmap.
count00	LC(1)	1		only 1 key allowed down
count01	?B=0	W	<-----	any more bits to count?
	GOYES   countok       | NO
count02	?B#0	P	<<--  |	any bits set in nibble?
	GOYES   double      | |
	BSR     W	   | |
	GONC	count01	----->	BET
double	B=B+B	P	    |	shift left until carry!
	GONC    double      |
	C=C-1   P	   |   more than one key held?
	GONC	count02	-->> 	NO, continue keys count
	GOTO	eztimeout	YES, keep scanning keys

** Compute key code of key being held down.
countok	ASRB.F	W
count03	?A#0	P	<---	\
	GOYES   count04    |     isolate
	B=B+CON B,4	|     the
	ASR     W	  |     nibble
	GONC	count03	---	/
count04	B=B+1	B	<---	\
	SB=0	       |     isolate
	ASRB.F  P	  |     the
	?SB=0	      |     bit
	GOYES	count03	---	/

** Turn on busy ann
busyon	D1=(5)	=ANNCTRL
	C=DAT1  B	       C[B]:[AON XTRA io busy alarm alpha -> <-]
	CBIT=1  4	       C[B]:[ *    *  *   1     *     *   *  * ]
	DAT1=C  B	       turn on busy annunciator
	RTNCC

**********************************************************************

DoTabKey	GOSUB	keytabs

	STITLE	Key Codes-Offsets Table, Version 1.1
*****************************************************************
*****************************************************************
**
** These are the offsets to the individual key routines.
**
*****************************************************************
*****************************************************************
	CON(3)	0	(0)	[ON]		      OR0
	REL(3)	badkey	(49)	[+]
	REL(3)	badkey	(48)	[SPC]
	REL(3)	badkey	(47)	[.]
	REL(3)	badkey	(46)	[0]
	REL(3)	badkey	(13)	[']

	REL(3)	badkey	(44)	[-]		      OR1
	REL(3)	badkey	(43)	[3]
	REL(3)	badkey	(42)	[2]
	REL(3)	badkey	(41)	[1]
	REL(3)	about	(1)	[A]
	REL(3)	badkey	(40)	right-shift

	REL(3)	badkey	(39)	[*]		      OR2
	REL(3)	badkey	(38)	[6]
	REL(3)	badkey	(37)	[5]
	REL(3)	badkey	(36)	[4]
	REL(3)	badkey	(7)	[MTH]
	REL(3)	badkey	(35)	left-shift

	REL(3)	badkey	(34)	[/]		      OR3
	REL(3)	badkey	(33)	[9]
	REL(3)	badkey	(32)	[8]
	REL(3)	badkey	(31)	[7]
	REL(3)	badkey	(19)	[SIN]
	REL(3)	badkey	(30)	alpha-shift

	REL(3)	badkey	(29)	[<=]		      OR4
	REL(3)	badkey	(28)	[DEL]
	REL(3)	badkey	(27)	[EEX]
	REL(3)	badkey	(26)	[+/-]
	REL(3)	doEnter	(25)    [ENTER]

	REL(3)	badkey	(24)	[1/X]		      OR5
	REL(3)	badkey	(23)	Y-to-the-X
	REL(3)	badkey	(22)	square-root
	REL(3)	badkey	(21)	[TAN]
	REL(3)	badkey	(20)	[COS]

	REL(3)	RGARROW	(18)	right-arrow	      OR6
	REL(3)	DNARROW	(17)	down-arrow
	REL(3)	LFARROW	(16)	left-arrow
	REL(3)	badkey	(15)	[EVAL]
	REL(3)	badkey	(14)	[STO]

	REL(3)	badkey	(12)	[NXT]		      OR7
	REL(3)	UPARROW	(11)	up-arrow
	REL(3)	badkey	(10)	[VAR]
	REL(3)	badkey	(9)	[CST]
	REL(3)	badkey	(8)	[PRG]

	REL(3)	badkey	(6)	[F]		      OR8
	REL(3)	badkey	(5)	[E]
	REL(3)	badkey	(4)	[D]
	REL(3)	badkey	(3)	[C]
	REL(3)	badkey	(2)	[B]

** Compute destination of the subroutine of the pressed key.
keytabs	C=RSTK
	C=C+B	A
	B=B+B	A
	C=C+B	A
	D1=C
	A=0	A
	A=DAT1	X
	A=A+C	A	* Note: carry clear
	INTON
	ST=1	15
	PC=A

	STITLE  Individual Key Subroutines, Ver 1.0
*****************************************************************
*****************************************************************
**
** These are the subroutines for each of the key assignments.
**
**
*****************************************************************
*****************************************************************
**
** Right arrow key.
RGARROW	A=R2
	A=A+1	A
	A=A+1	A
	GOTO	RDARem

** Down arrow key.
DNARROW	A=R2
	A=A+CON	A,16
	A=A+CON	A,16
RDARem	C=R1
	B=C	A
	LC(5)	255*2
	C=C+B	A
	?A<=C	A
	GOYES	+
	GOTO	badkey
+	R2=A
	CD0EX
	D0=C
	A=A-C	A
	LC(5)	#70*2
	?A<C	A
	RTNYES
	D0=D0+	16
	D0=D0+	16
	RTN

** Left arrow key.
LFARROW	A=R2
	A=A-1	A
	A=A-1	A
	GOTO	LUARem

** Up arrow key.
UPARROW	A=R2
	A=A-CON	A,16
	A=A-CON	A,16
LUARem	C=R1
	?A>=C	A
	GOYES	+
	GOTO	badkey
+	R2=A
	CD0EX
	D0=C
	A=A-C	A
	LC(5)	#70*2
	?A<C	A
	RTNYES
	D0=D0-	16
	D0=D0-	16
	RTN

** Do ENTER-key
doEnter
*	DEBUG
	GOSBVL  =D1=DSKTOP      D1=->DATA STR
	C=DAT1	A
	D1=C		    D1=->PROLOG
	D1=D1+  10	      D1=->data section
	CD0EX
	DAT1=C  A	       Save D0

	C=0	A
	?ST=0	ezPUSHED	First time?
	GOYES	+		Skip
	D1=D1+	5
	C=DAT1	A		Read address to string
	D1=C
	D1=D1+	5		Point to size
	C=DAT1	A		Read size
	C=C-CON	A,5
+	C=C+1	A
	C=C+1	A
	ST=1	sGARBAGE	Flag garbage already collected
	GOSBVL	(=MAKE$N)+3	Create new string
	?ST=0	ezPUSHED	First one?
	GOYES	+		Skip
	CD0EX
	D1=C			D1=->string body

	GOSBVL	=D0=DSKTOP
	C=DAT0  A		Read data string
	D0=C			D0=->PROLOG
	D0=D0+  15		D0=->address save

	C=DAT0	A
	D0=C
	D0=D0+	5

	C=DAT0  A	       C[A]=size of old string
	D0=D0+  5	       D0=->data section of old string
	C=C-CON	A,5
	GOSBVL	=MOVEDOWN	Copy C[A] nibbles from D0 to D1
	CD1EX
	D0=C
+	ST=1	ezPUSHED
	C=R2
	D1=C
	C=DAT1	B
	DAT0=C	B

	GOSBVL	=D1=DSKTOP
	C=DAT1	A
	D1=C
	D1=D1+  10	      D1=->DATASECTION
	C=DAT1	A
	D0=C
	D1=D1+	5
	C=R0
	DAT1=C	A
	GOTO	NODOWN?

** Write about-screen
about
	GOSBVL  =D1=DSKTOP      D1=->DATA STR
	C=DAT1	A
	D1=C		    D1=->PROLOG
	D1=D1+  10	      D1=->data section
	CD0EX
	DAT1=C  A	       Save D0

	GOSUB	erase
	GOSUB	+
	NIBASC	'EZ-CHARACTER ver 1.2a '
+	C=RSTK	
	D0=C
	LC(5)	22
	D=C	A
	C=R3
	D1=C
	GOSUB	disp$D0
	
	GOSUB	+
	NIBASC	'By Daniel Lidstrm '98'
+	C=RSTK	
	D0=C
	LC(5)	22
	D=C	A
	C=R3
	LA(5)	34*9
	C=C+A	A
	D1=C
	GOSUB	disp$D0
	
	GOSUB	+
	NIBASC	'danli97@ite.mh.se '
+	C=RSTK	
	D0=C
	LC(5)	18
	D=C	A
	C=R3
	LA(5)	34*18
	C=C+A	A
	D1=C
	GOSUB	disp$D0
	
	GOSUB	+
	NIBASC	'www.ite.mh.se/~danli97'
+	C=RSTK	
	D0=C
	LC(5)	22
	D=C	A
	C=R3
	LA(5)	34*27
	C=C+A	A
	D1=C
	GOSUB	disp$D0
	
	GOSBVL	=D1=DSKTOP
	C=DAT1	A
	D1=C
	D1=D1+  10	      D1=->DATASECTION
	C=DAT1	A
	D0=C
	GOSUB	NODOWN?
	GOSUB	erase
	GOTO	putabout

** Do bad key beep.
badkey	?ST=0	ezSOUND
	GOYES	NODOWN?
	LC(2)	#F4
	GOSBVL	=RCKBp

** Do nothing while key(s) down!
NODOWN?	LC(5)	=allkeys	<------------------+
	OUT=C   load		all keyboard	   |
	GOSBVL  =CINRTN				   |
	?C#0    A		loop until it's 0  |
	GOYES	NODOWN?		 ------------------>
	RTN

	STITLE	Main Memory Dump Display Routine, Version 1.1
** begin dispdmp ************************************************
*****************************************************************
**
** NAME: dispdmp
**
** CATEGORY: Display
**
** ENTRY: D0->:1st nibble of current memory dump screen
**	R2->:current cursor position
**	R3->:upper most left-hand corner of display GROB
**
** EXIT: D0 is trashed and must be saved by the caller!
**		    
** CALLS: dispA[], disp@D0, disp$D0
**
** STACK LEVELS: 2
**
** ABSTRACT: Displays the memory dump screen.
**
** MODULE HISTORY:
**
** Written			08/08/93	Rick Grevelle
** Optimized			09/03/93	Rick Grevelle
** ASCII display mode added	10/08/93	Rick Grevelle
**
*****************************************************************
*****************************************************************
** Prepare to display the current memory dump screen.
dispdmp	P=	15
	LCHEX	6
	P=	0
	D=C	S	D[S]:row counter
	A=R3
	D1=A
	ST=0	ezCURSOR

** Setup and display a row address of memory dump.
rowloop	D1=D1+	9
	LC(5)	16
	D=C	A	* D[A] = 16 chars
	GOSUB	disp$D0
	GOSUB   CURSOR?
	AD1EX
	LC(5)	(onerow)*7+1
	A=A+C	A
	AD1EX
	D=D-1	S
	GONC	rowloop

* Display current ASCII-value

	C=R2
	D1=C
	A=0	A
	A=DAT1	B
	LC(2)	#19
	B=0	A
-	B=B+B	A
	SETHEX
	A=A+A	A
	SETDEC
	GONC	+
	B=B+1	A
+	C=C-1	B
	GONC	-
	SETHEX
	C=R3
	LA(5)	34*40
	C=C+A	A
	D1=C

	C=B	X	C[X]=num
	D=C	X
	CSR	X
	CSR	B
	LA(2)	48
	C=C+A	B
	LAASC	'#'
	GOSUB	WRCHR2
	C=D	X
	CSR	B
	LA(2)	48
	C=C+A	B
	B=C	B
	C=D	B
	CSL	B
	CSR	B
	LA(2)	48
	C=C+A	B
	GOSUB	WRCHR2!

	STITLE Big Character
*****************************************************************
*****************************************************************
**
** NAME: dspchr*4
**
** CATEGORY: Display
**
** ENTRY: A[A]=offset into display
**	  D1=->font
**
** EXIT: D0 is trashed and must be saved by the caller!
**		    
*****************************************************************
*****************************************************************
* setup registers

	C=R2
	A=R1
	C=C-A	A
	C=C+C	A
	C=C+C	A
	C=C+C	A
	A=R4
	C=C+A	A
	D1=C
	A=0	A
dspchr*4
	C=R3
	A=A+C	A
	D0=A
	P=	15
	LCHEX	7
	P=	0
	D=C	S
--	A=0	W
	C=DAT1	B
	D1=D1+	2
	?CBIT=0	0
	GOYES	+
	A=A-1	P
+	?CBIT=0	1
	GOYES	+
	P=	1
	A=A-1	P
+	?CBIT=0	2
	GOYES	+
	P=	2
	A=A-1	P
+	?CBIT=0	3
	GOYES	+
	P=	3
	A=A-1	P
+	?CBIT=0	4
	GOYES	+
	P=	4
	A=A-1	P
+	?CBIT=0	5
	GOYES	+
	P=	5
	A=A-1	P
+	P=	0
	DAT0=A	6
	D0=D0+	34
	DAT0=A	6
	D0=D0+	34
	DAT0=A	6
	D0=D0+	34
	DAT0=A	6
	D0=D0+	34
	D=D-1	S
	RTNC
	GOTO	--

	STITLE	Conditional Cursor Display-Update, Version 1.1
** begin CURSOR? ************************************************
*****************************************************************
**
** NAME: CURSOR?
**
** CATEGORY: Display
**
** ENTRY: D0->:1st nibble of some row in memory dump
**	R2->:current cursor position in memory dump
**	R3->:upper most left-hand corner of display GROB
**
** EXIT: (same as ENTRY:)
**		    
** CALLS: None
**
** STACK LEVELS: 0 (?)
**
** ABSTRACT: Displays a cursor at current cursor position.
**
** MODULE HISTORY:
**
** Written			10/08/93	Rick Grevelle
**
*****************************************************************
*****************************************************************
CURSOR?	?ST=0	ezCURSOR
	RTNYES
	ST=0	ezCURSOR
	CD0EX
	RSTK=C
	A=R2
	A=A-C	A
	B=0	A
	ASRB.F	A
	B=A	P	B[A]:remainder
	AD1EX
	D1=A
	LC(5)	(onerow)*1-1
	C=A-C	A
	D=C	A
	GOTO	getmask


**********************************************************************
* Name:		CURSOR+
* Entry:	D0    = ->memory (1st nibble in dump)
*		R2[A] = ->cursor position in dump
*		R3[A] = ->display (upper left corner)
* Exit:		Above
* Stack:	1
**********************************************************************
CURSOR+	CD0EX
	RSTK=C
	A=R2
	A=A-C	A	* A[A]=offset to cursor
	ASRB.F	A	* Offset in chars
	B=0	A
	B=A	P	* X location
	ASR	A	* Y location

* Calculate display row
* Note: (onerow)*8 = 34*8 = 272 = #110

	C=A	A	* Y
	CSL	A	* #10*Y
	D=C	A
	CSL	A	* #100*Y
	D=D+C	A	* #110*Y
	C=R3
	D=D+C	A	* D[A] = ->disprow

* Add X location and prepare mask

getmask	A=B	A					     [ 7]
	ABIT=0  0					    [ 6]
	LC(3)	#3F	C[X]:odd mask			     [ 6]
**	LC(3)	#3F8	(** cursor width expansion experiment **)
	SB=0						 [ 3]
	BSRB.F  A					    [11]
	?SB=0					   [13]/[ 6]
	GOYES	add1/2	STICKY BIT SET IF THE CURSOR IS 6 MSB!!!!
	LC(4)   #FC0					 [ 7]
**	LC(4)	#FE0	(** cursor width expansion experiment **)
add1/2	B=B+A	A					     [ 7]
**	B=B-1	A	(** cursor width expansion experiment **)
	CDEX	A	D[X]:has mask; C[A]:row offset	     [ 7]
	C=C+B   A					    [ 7]
	D0=C						 [ 8]
	D0=D0+  9					    [ 7]


	STITLE	Toggle Display Cursor, Ver 1.0
*****************************************************************
*****************************************************************
**
** NAME: cursor!
**
** ENTRY: D0->:cursor MARK
**	D[X]:cursor mask
**	RSTK:memory save
**
** EXIT: D0 restored
**
*****************************************************************
*****************************************************************
cursor!	P=	16-8					     [ 2]
cursor+	C=DAT0	3	<---	C[X]:the pixel row	     [19]
	A=C     X	 |       save the pixel row	 [ 6]
	C=C&D   X	 |       \			  [ 7]
	C=-C-1  X	 |       \			  [ 6]
	ACEX    X	 |	COMPUTES A CURSOR	 [ 7]
	C=C!D   X	 |       /			  [ 7]
	C=C&A   X	 |       /			  [ 7]
	DAT0=C  3	 |       sets the pixel row	 [18]
	D0=D0+  16	|       \			  [ 7]
	D0=D0+  16	|	moves to next row	 [ 7]
	D0=D0+  2	 |       /			  [ 7]
	P=P+1	     |				  [ 3]
	GONC	cursor+	---				[10]/[ 3]
	C=RSTK					       [ 8]
	D0=C						 [ 8]
	RTN						  [ 9]


*****************************************************************
* Name:		disp$D0
* Entry:	D0 = ->memory
*		D1 = ->display
*		D[A] = #chars
* Exit:		D0 = ->memory (next)
*		D1 = ->display (next)
* Uses:		A[W] B[A] C[W] D[A] D0 D1 P CRY
* Calls:	WRCHR2 CRSIN?
* Stack:	1
* Description:	Displays D[A] ascii chars at D0.
*****************************************************************

disp$D0	D=D+D	A
	GOSUB	CRSIN?
	DSRB.F	A
	DSRB.F	A
	GOTO	d$D0.3

d$D0.2	A=DAT0	B		* A[B] = chr1
	D0=D0+	2
	C=DAT0  B	       * C[B] = chr2
	D0=D0+	2
	GOSUB	WRCHR2
d$D0.3	D=D-1	A
	GONC	d$D0.2
	RTNCC


	STITLE	Char-to-Display	Write Loop, Ver 1.0
**********************************************************************
* Name:		WRCHR2
* Entry:	D1 = ->display
*		A[B] = chr1
*		C[B] = chr2
* Exit:		D1 = ->display (next location)
* Uses:		A[W] B[A] C[W] P D1
* Stack:	0
* Alternate:	WRCHR2!	B[B]=chr1 C[B]=chr2
**********************************************************************

WRCHR2	B=A	B	* B[B] = chr1
WRCHR2!	CSL	X
	P=	3
	LC(2)	0
	P=	0
	A=R4	*	A[A] = ->font
	A=A+C	A
	AD0EX
	C=DAT0	W	* C[W] = data2
	AD0EX
	CBEX	A	* C[B] = chr1
	CSL	X
	P=	3
	LC(2)	0
	P=	0
	A=R4
	C=C+A	A
	CD0EX
	A=DAT0	W	* A[W] = data1
	CD0EX
	C=B	A	* C[W] = data2

* Fall through

	STITLE	Pixel-to-Display	Write
**********************************************************************
* Name:		WRPIX2
* Entry:	D1 = ->display
*		A[W] = font data for 1st char
*		C[W] = font data for 2nd char
* Exit:		D1 = ->display (next location)
* Uses:		A[W] C[W] P D1
* Stack:	0
*****************************************************************
WRPIX2	C=C+C	W		[19]
	C=C+C   W	       [19]

** Loop version:

*	DAT1=A	P		[17]
*	D1=D1+	1		[ 7]
*	ASR	W		[20]
*	GONC	WR2IN		[10]
*WR2LP	D1=D1+	16		[ 7]
*	D1=D1+	16		[ 7]
*	DAT1=A	P		[17]
*	D1=D1+	1		[ 7]
*	P=P+1			[ 3]
*WR2IN	A=A+C	P		[ 4]
*	DAT1=A	P		[17]
*	D1=D1+	1		[ 7]
*	P=P+1			[ 3]
*	DAT1=C	P		[17]
*	?P#	15		[13/6] = [102]
*	GOYES	WR2LP
*	P=	0
*	AD1EX
*	LC(5)	(onerow)*7-1	* Advance D1 2 chars
*	A=A-C	A
*	AD1EX
*	RTNCC

** Loop removed:

	DAT1=A	P
	D1=D1+	1
	ASR	W
	A=A+C	P
	DAT1=A	P
	D1=D1+	1
	P=	1
	DAT1=C	P

	D1=D1+	16
	D1=D1+	16
	DAT1=A	P
	D1=D1+	1
	P=	2
	A=A+C	P
	DAT1=A	P
	D1=D1+	1
	P=	3
	DAT1=C	P

	D1=D1+	16
	D1=D1+	16
	DAT1=A	P
	D1=D1+	1
	P=	4
	A=A+C	P
	DAT1=A	P
	D1=D1+	1
	P=	5
	DAT1=C	P

	D1=D1+	16
	D1=D1+	16
	DAT1=A	P
	D1=D1+	1
	P=	6
	A=A+C	P
	DAT1=A	P
	D1=D1+	1
	P=	7
	DAT1=C	P

	D1=D1+	16
	D1=D1+	16
	DAT1=A	P
	D1=D1+	1
	P=	8
	A=A+C	P
	DAT1=A	P
	D1=D1+	1
	P=	9
	DAT1=C	P

	D1=D1+	16
	D1=D1+	16
	DAT1=A	P
	D1=D1+	1
	P=	10
	A=A+C	P
	DAT1=A	P
	D1=D1+	1
	P=	11
	DAT1=C	P

	D1=D1+	16
	D1=D1+	16
	DAT1=A	P
	D1=D1+	1
	P=	12
	A=A+C	P
	DAT1=A	P
	D1=D1+	1
	P=	13
	DAT1=C	P

	D1=D1+	16
	D1=D1+	16
	DAT1=A	P
	D1=D1+	1
	P=	14
	A=A+C	P
	DAT1=A	P
	D1=D1+	1
	P=	15
	DAT1=C	P

	P=	0
	AD1EX
	LC(5)	(onerow)*7-1	* Advance D1 2 chars
	A=A-C	A
	AD1EX
	RTNCC


	STITLE	Misc Utilities

**********************************************************************
* Set ezCURSOR and return CC if D0 <= R2[A] < D0+D[A]
**********************************************************************
CRSIN?	AD0EX
	D0=A
	C=R2
	?C<A	A	* Cursor already done
	RTNYES
	C=D	A
	A=A+C	A
	C=R2
	?C>=A	A
	RTNYES
	ST=1	ezCURSOR
	RTNCC

erase	C=R3
	D1=C
	LC(5)	34*56/16-1
	A=0	W
-	DAT1=A	W
	D1=D1+	16
	C=C-1	A
	GONC	-
	RTN

EZINIT
** Setup flags
	CLRST		   initialize to default
	ST=0    ezPRESS	 Assume no key is down

* Pop sound flag
	ST=1	ezSOUND
	GOSBVL	=popflag
	GONC	+
	ST=0	ezSOUND

** Pop string
+	A=DAT1	A
	D1=D1+	5
	D=D+1	A
	A=A+CON	A,10
	R2=A		    *       R2[A] = ->cursor address
	R1=A		    *       R1[A] = ->cursor start address

** Pop font
	A=DAT1	A
	D1=D1+	5
	D=D+1	A
	A=A+CON	A,10
	R4=A		    *       R4[A] = ->font
	GOSBVL	=SAVPTR

	GOSUB	+
	INCLOB	EZTITLE.GRO
+	C=RSTK
	D1=C
	GOSBVL	=D0->Row1
	P=	16-7
-	C=DAT1	W
	DAT0=C	W
	D1=D1+	16
	D0=D0+	16
	C=DAT1	W
	DAT0=C	W
	D1=D1+	16
	D0=D0+	16
	C=DAT1	B
	DAT0=C	B
	D1=D1+	2
	D0=D0+	2
	P=P+1
	GONC	-

	LC(5)	8*34
	A=A+C	A
	D0=A
	R3=A

putabout
	LC(5)	34*49
	AD0EX
	B=A	A
	A=R3
	A=A+C	A
	D0=A
	GOSUB	+
	INCLOB	ABOUT.GRO
+	C=RSTK
	D1=C
	P=	16-7
-	C=DAT1	6
	DAT0=C	6
	D1=D1+	6
	D0=D0+	34
	P=P+1
	GONC	-
	A=B	A
	D0=A
	GOTO	NODOWN?
ENDCODE

;
**********************************************************************
